uniform mediump float uAngle;
uniform mediump float uStartOpacity;
uniform mediump float uEndOpacity;
uniform mediump float uSmoothness;
uniform lowp vec3 color0;
uniform lowp vec3 color1;
uniform mediump vec2 srcOriginStart;
uniform mediump vec2 srcOriginEnd;
varying mediump vec2 vTex;
uniform lowp sampler2D samplerFront;
precision mediump float;

void main() {
vec4 front = texture2D(samplerFront, vTex);
vec4 startColor = vec4(color0, 1.);
vec4 endColor = vec4(color1, 1.);

float currentAngle = -uAngle;

mediump vec2 srcOriginSize = srcOriginEnd - srcOriginStart;
mediump vec2 uv = ((vTex - srcOriginStart) / srcOriginSize);

vec2 origin = vec2(0.5, 0.5);
uv -= origin;
float angle = radians(90.0) - radians(currentAngle) + atan(uv.y, uv.x);
float len = length(uv);
uv = vec2(cos(angle) * len, sin(angle) * len) + origin;
float t = smoothstep(.5 + uSmoothness , .5 - uSmoothness, uv.x);
startColor = mix(front, startColor, uStartOpacity);
endColor = mix(front, endColor, uEndOpacity);

gl_FragColor = mix(startColor, endColor, t) * front.a;
}