﻿%%FRAGMENTINPUT_STRUCT%%

%%FRAGMENTOUTPUT_STRUCT%%

%%SAMPLERFRONT_BINDING%% var samplerFront : sampler;
%%TEXTUREFRONT_BINDING%% var textureFront : texture_2d<f32>;

//%//%SAMPLERBACK_BINDING%//% var samplerBack : sampler;
//%//%TEXTUREBACK_BINDING%//% var textureBack : texture_2d<f32>;

//%//%SAMPLERDEPTH_BINDING%//% var samplerDepth : sampler;
//%//%TEXTUREDEPTH_BINDING%//% var textureDepth : texture_depth_2d;

struct ShaderParams {
	color0 : vec3<f32>,
	uStartOpacity : f32,
	color1 : vec3<f32>,
	uEndOpacity : f32,
	uAngle : f32,
	uSmoothness : f32
};
%%SHADERPARAMS_BINDING%% var<uniform> shaderParams : ShaderParams;


%%C3PARAMS_STRUCT%%


%%C3_UTILITY_FUNCTIONS%%

@fragment
fn main(input : FragmentInput) -> FragmentOutput
{
	let front: vec4<f32> = textureSample(textureFront, samplerFront, input.fragUV);
	var startColor: vec4<f32> = vec4<f32>(shaderParams.color0, 1.);
	var endColor: vec4<f32> = vec4<f32>(shaderParams.color1, 1.);

	let currentAngle: f32 = -shaderParams.uAngle;
	var uv: vec2<f32> = c3_srcOriginToNorm(input.fragUV);

	let origin: vec2<f32> = vec2<f32>(0.5, 0.5);
	uv = uv - (origin);
	let angle: f32 = radians(90.) - radians(currentAngle) + atan2(uv.y, uv.x);
	let len: f32 = length(uv);
	uv = vec2<f32>(cos(angle) * len, sin(angle) * len) + origin;
	let t: f32 = smoothstep(.5 + shaderParams.uSmoothness, .5 -shaderParams.uSmoothness, uv.x);
	startColor = mix(front, startColor, shaderParams.uStartOpacity);
	endColor = mix(front, endColor, shaderParams.uEndOpacity);
	
	var output : FragmentOutput;
	output.color = mix(startColor, endColor, t) * front.a;
	return output;
}
